package com.hotwj.platform.noticeManagerment.companyNotice.service;

import com.hotwj.platform.noticeManagerment.companyNotice.domain.bo.HotCompanyNoticeBo;
import com.hotwj.platform.noticeManagerment.companyNotice.domain.vo.HotCompanyNoticeVo;
import org.dromara.common.mybatis.core.page.PageQuery;
import org.dromara.common.mybatis.core.page.TableDataInfo;

import java.util.Collection;
import java.util.List;

/**
 * 公司公告Service接口
 *
 * @author shihongwei
 * @date 2026-01-07
 */
public interface IHotCompanyNoticeService {

    /**
     * 查询公司公告
     *
     * @param id 主键
     * @return 公司公告
     */
    HotCompanyNoticeVo queryById(Long id);

    /**
     * 分页查询公司公告列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 公司公告分页列表
     */
    TableDataInfo<HotCompanyNoticeVo> queryPageList(HotCompanyNoticeBo bo, PageQuery pageQuery);

    /**
     * 查询符合条件的公司公告列表
     *
     * @param bo 查询条件
     * @return 公司公告列表
     */
    List<HotCompanyNoticeVo> queryList(HotCompanyNoticeBo bo);

    HotCompanyNoticeVo queryLatestUnread();

    /**
     * 新增公司公告
     *
     * @param bo 公司公告
     * @return 是否新增成功
     */
    Boolean insertByBo(HotCompanyNoticeBo bo);

    /**
     * 修改公司公告
     *
     * @param bo 公司公告
     * @return 是否修改成功
     */
    Boolean updateByBo(HotCompanyNoticeBo bo);

    /**
     * 校验并批量删除公司公告信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid);

    Boolean markRead(Long id);
}
